using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Security.Cryptography.X509Certificates;

public class Log : MonoBehaviour
{
	public GameObject Dust;
    public AudioClip LogBreakSound;
    public AudioClip LogHitSound;
	public int SwordsToBreak;

	private GameManager gameManager;
    private GameObject logBody;
	private GameObject apple;

	private float rotateDir = -1f;
    void Awake()
	{
		SwordsToBreak = FalcoEngine.Random.Range(5, 10);
    }
	void Start()
	{
		logBody = transform.GetChild(0).gameObject;
		apple = transform.GetChild(1).gameObject;
		gameManager = FindObjectOfType<GameManager>();
		Rotate(FalcoEngine.Random.Range(-360, 360));
	}
	
	void Update()
	{
		Rotate(rotateDir);
	}

	void Rotate(float angle)
	{
		transform.rotation *= Quaternion.AngleAxis(angle, Vector3.forward);
	}
	public void OnHit()
	{
        gameManager.UpdateScore(15);
        SwordsToBreak--;
        PlayLogHitSound();
		rotateDir = FalcoEngine.Random.Range(-2.0f, 2.0f)*2;

        if (SwordsToBreak <= 0)
		{
			BreakLog();
		}
	}

	void BreakLog()
	{
        PlayLogBreakSound();
		logBody.enabled = false;
		if (apple != null)
		{
            apple.enabled = false;
        }
		Sword[] swords = FindObjectsOfType<Sword>();
		foreach (Sword sword in swords)
		{
			
			sword.rigidbody.isKinematic = false;
			sword.rigidbody.linearVelocity = Vector3.zero;
			sword.rigidbody.AddForce(new Vector3(FalcoEngine.Random.Range(-1, 1), FalcoEngine.Random.Range(-1, 1), FalcoEngine.Random.Range(-1, 1)) * 100);
			sword.rigidbody.AddTorque(new Vector3(FalcoEngine.Random.Range(-1, 1), FalcoEngine.Random.Range(-1, 1), FalcoEngine.Random.Range(-1, 1)) * 100);

        }
		Dust.enabled = true;
		gameManager.Win();

	}
    void PlayLogBreakSound()
    {
        audioSource.audioClip = LogBreakSound;
        audioSource.Play();
    }
    void PlayLogHitSound()
    {
        audioSource.audioClip = LogHitSound;
        audioSource.Play();
    }

}
