using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class Sword : MonoBehaviour
{
    public AudioClip KnifeThrowSound;
    public AudioClip AppleHitSound;
    public AudioClip KnifeHitsKnifeSound;
    public float Speed;

	private Log log;
	private GameManager gameManager;
	private SwordSpawner swordSpawner;
	private bool moveUp = false;
	void Start()
	{
		log = FindObjectOfType<Log>();	
		swordSpawner = FindObjectOfType<SwordSpawner>();
		gameManager = FindObjectOfType<GameManager>();
	}
	
	void Update()
	{
		
		if (log.gameObject != null)
		{
            if (Input.GetMouseButtonDown(0) && moveUp == false)
            {
                moveUp = true;
                rigidbody.isKinematic = false;
				PlayKnifeThrowSound();

            }
            float distance = Vector3.Distance(transform.position, log.transform.position);

            if (distance <= 2.5f)
            {
                moveUp = false;
                rigidbody.isKinematic = true;
                transform.parent = log.transform;
                log.OnHit();
                swordSpawner.SpawnNewSword();
                this.enabled = false;
            }

            MoveUp();
        }
	}

	void MoveUp()
	{
		if (moveUp)
		{
			rigidbody.linearVelocity = Vector3.up * Speed;
        }
    }

	void OnCollisionEnter(Collision col)
	{
		if(col.other.gameObject.name == "Apple")
		{
			gameManager.UpdateScore(30);
			PlayAppleHitSound();
			Destroy(col.other.gameObject);
		}

        if (col.other.gameObject.name == "Sword")
        {
            GameOver();
        }
    }

    void PlayKnifeThrowSound()
    {
        audioSource.audioClip = KnifeThrowSound;
        audioSource.Play();
    }

    void PlayAppleHitSound()
    {
        audioSource.audioClip = AppleHitSound;
        audioSource.Play();
    }
    void PlayHnifeHitsKnifeSound()
    {
        audioSource.audioClip = KnifeHitsKnifeSound;
        audioSource.Play();
    }   
    void GameOver()
    {
        PlayHnifeHitsKnifeSound();
        moveUp = false;
        rigidbody.linearVelocity = Vector3.zero;
        rigidbody.AddForce(new Vector3(FalcoEngine.Random.Range(-1, 1), FalcoEngine.Random.Range(-1, 1), FalcoEngine.Random.Range(-1, 1)) * 100);
        rigidbody.AddTorque(new Vector3(FalcoEngine.Random.Range(-1, 1), FalcoEngine.Random.Range(-1, 1), FalcoEngine.Random.Range(-1, 1)) * 100);
        gameManager.GameOver();
        Destroy(this);
    }
}
